/* For free support for VSIDE, please visit www.vsdsp-forum.com */


/**

	\file simplemp3.c A very simple MP3/WAV player.
	
	This is a template for a very simple MP3/WAV player. By using the code in this
	player, you can easily add MP3 playback functionality to your own programs.
	
	This will create a <projectname>.APP file, which you can copy to
	your VS1005 Developer Board and run it from there. To hear audio,
	please copy also a file named TEST.WAV to the card.
	
	If you rename your application to INIT.APP, then the kernel will
	load it automatically after booting.

    NOTE: This is a special release that supports MP3/WAV playback although VSOS
    doesn't yet fully support this at the time of writing (130322). Because of this,
    parts of the operating system, namely decodeAudio.c and .h, and libcodecwav.a,
    are integrated to this application. Later this functionality will be included
    in VSOS, and a playback application will become simpler.
	
*/

	
#include <vo_stdio.h>
#include <stdlib.h>
#include <codec.h>
#include <sysmemory.h>
#include "decodeAudio.h"
	
	
	
/* Following are the minimum amounts of Malloc Area for MP3 decoding to work.*/
__x s_int16 xmemPool[7500];
__y s_int16 ymemPool[3900];
	
int main(void) {	
	FILE *inFp = NULL;
	AUDIO_DECODER *dec = NULL;
	const char *eStr = NULL;
	int eCode = 0;	
	int result = S_OK;
	
	/* Initialize memory allocation pools for the decoder. */
	__InitMemAlloc(xmemPool, sizeof(xmemPool), ymemPool, sizeof(ymemPool));
	
	/* Replace the file name you want to play here. Don't forget to begin
	the name with "S:" for "System Disk". */

	printf("Opening TEST.WAV...\n");	
	inFp = fopen("S:TEST.WAV", "rb");
	if (!inFp) {
		printf("Couldn't open TEST.WAV for reading.\n");
		result = S_ERROR;
		goto end;
	}
	
	/* We could give a hint of the the file format, but we'll leave it to
	the decoder to determine. This is OK if the file is seekable. */
	printf("Starting the decoder...\n");
	dec = CreateAudioDecoder(inFp, stdaudioout, NULL, auDecFGuess);
	if (!dec) {
		printf("Couldn't create decoder\n");
		result = S_ERROR;
		goto end;
	}
	
	printf("Decoding audio...\n");
	eCode = DecodeAudio(dec, &eStr);
	printf("Decoder returns %d, \"%s\"\n", eCode, eStr ? eStr : "(null)");
	
	end:
	printf("Clean-up.\n");
	
	if (dec) {
		DeleteAudioDecoder(dec);
		dec = NULL;
	}
	if (inFp) {
		fclose(inFp);
		inFp = NULL;
	}
	return result;
}
