/*

  MP3 Decoder Model (C) 2012-07-13 VLSI Solution Oy
  This model can play back MP3 files on VS1005g.

  This model can handle the following UI messages:
  - UIMSG_VSOS_SET_CALLBACK_FUNCTION
  - UIMSG_VSOS_GET_MSG_LIST
  - UIMSG_BUT_FIRST
  - UIMSG_BUT_PREVIOUS
  - UIMSG_BUT_NEXT
  - UIMSG_BUT_LAST
  - UIMSG_BUT_RESTART
  - UIMSG_TEXT_OPEN_FILE
  - UIMSG_BUT_STOP
  - UIMSG_BUT_PAUSE
  - UIMSG_BUT_PAUSE_TOGGLE
  - UIMSG_BOOL_FAST_FORWARD
  - UIMSG_BUT_CLOSE_DECODER

  This model sends the following UI messages:
  - UIMSG_VSOS_MSG_LIST
  - UIMSG_S16_PLAYING
  - UIMSG_U32_PLAY_TIME_SECONDS
  - UIMSG_U32_PLAY_FILE_PERCENT
  - UIMSG_TEXT_SHORT_FILE_NAME
  - UIMSG_TEXT_LONG_FILE_NAME
  - UIMSG_TEXT_SONG_NAME
  - UIMSG_TEXT_ALBUM_NAME
  - UIMSG_TEXT_ARTIST_NAME
  - UIMSG_TEXT_YEAR
  - UIMSG_BUT_END_OF_SONG
  - UIMSG_S16_ERROR
  - UIMSG_BUT_DECODER_CLOSED

*/
#ifndef VSOS_MP3_MODEL_H
#define VSOS_MP3_MODEL_H

#include <vstypes.h>


/* Calling this controls the MP3 player */
void ModelCallback(s_int16 index, u_int16 message, u_int32 value);
void ModelTask(void);

extern u_int16 playerFlags;

#endif /* !VSOS_MP3_MODEL_H */
